"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var view_1 = require("tns-core-modules/ui/core/view");
var text_base_1 = require("tns-core-modules/ui/text-base");
var color_1 = require("tns-core-modules/color");
var MPChartBase = (function (_super) {
    __extends(MPChartBase, _super);
    function MPChartBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MPChartBase.prototype.resetZoomLineChart = function () {
    };
    return MPChartBase;
}(view_1.View));
exports.MPChartBase = MPChartBase;
exports.itemsProperty = new view_1.Property({
    name: "items"
});
exports.itemsProperty.register(MPChartBase);
exports.labelsProperty = new view_1.Property({
    name: "labels"
});
exports.labelsProperty.register(MPChartBase);
exports.showLegendProperty = new view_1.Property({
    name: "showLegend",
    defaultValue: true,
    valueConverter: view_1.booleanConverter
});
exports.showLegendProperty.register(MPChartBase);
exports.showGridLinesProperty = new view_1.Property({
    name: "showGridLines",
    defaultValue: false,
    valueConverter: view_1.booleanConverter
});
exports.showGridLinesProperty.register(MPChartBase);
exports.scaleEnableProperty = new view_1.Property({
    name: "scaleEnable",
    defaultValue: false,
    valueConverter: view_1.booleanConverter
});
exports.scaleEnableProperty.register(MPChartBase);
exports.descriptionTextProperty = new view_1.Property({
    name: "descriptionText",
    defaultValue: "",
    valueConverter: function (v) {
        if (v || v === '') {
            return v.toString();
        }
        else {
            return "";
        }
    }
});
exports.descriptionTextProperty.register(MPChartBase);
exports.descriptionXOffsetProperty = new view_1.Property({
    name: "descriptionXOffset",
    defaultValue: 0,
    valueConverter: function (v) {
        if (parseFloat(v) !== NaN) {
            return parseFloat(v);
        }
        throw new Error("Property 'descriptionXOffset' must be a number");
    }
});
exports.descriptionXOffsetProperty.register(MPChartBase);
exports.descriptionYOffsetProperty = new view_1.Property({
    name: "descriptionXOffset",
    defaultValue: 0,
    valueConverter: function (v) {
        if (parseFloat(v) !== NaN) {
            return parseFloat(v);
        }
        throw new Error("Property 'descriptionYOffset' must be a number");
    }
});
exports.descriptionYOffsetProperty.register(MPChartBase);
exports.descriptionTextColorProperty = new view_1.Property({
    name: "descriptionTextColor",
    valueConverter: function (v) {
        if (v) {
            return new color_1.Color(v);
        }
        else {
            return new color_1.Color("#000000");
        }
    }
});
exports.descriptionTextColorProperty.register(MPChartBase);
exports.descriptionTextColorCssProperty = new text_base_1.CssProperty({
    name: "descriptionTextColor",
    cssName: "description-text-color",
    valueConverter: function (v) {
        if (v) {
            return new color_1.Color(v);
        }
        else {
            return new color_1.Color("#000000");
        }
    }
});
exports.descriptionTextColorCssProperty.register(text_base_1.Style);
exports.highlightPerTapEnabledProperty = new view_1.Property({
    name: "highlightPerTapEnabled",
    defaultValue: false,
    valueConverter: view_1.booleanConverter
});
exports.highlightPerTapEnabledProperty.register(MPChartBase);
exports.highlightPerDragEnabledProperty = new view_1.Property({
    name: "highlightPerDragEnabled",
    defaultValue: false,
    valueConverter: view_1.booleanConverter
});
exports.highlightPerDragEnabledProperty.register(MPChartBase);
exports.xAxisGranularityProperty = new view_1.Property({
    name: "xAxisGranularity",
    defaultValue: 1,
    valueConverter: function (v) {
        if (parseFloat(v) !== NaN) {
            return parseFloat(v);
        }
        throw new Error("Property 'xAxisGranularity' must be a number");
    }
});
exports.xAxisGranularityProperty.register(MPChartBase);
exports.leftAxisGranularityProperty = new view_1.Property({
    name: "leftAxisGranularity",
    valueConverter: function (v) {
        if (parseFloat(v) !== NaN) {
            return parseFloat(v);
        }
        throw new Error("Property 'leftAxisGranularity' must be a number");
    }
});
exports.leftAxisGranularityProperty.register(MPChartBase);
exports.rightAxisGranularityProperty = new view_1.Property({
    name: "rightAxisGranularity",
    valueConverter: function (v) {
        if (parseFloat(v) !== NaN) {
            return parseFloat(v);
        }
        throw new Error("Property 'rightAxisGranularity' must be a number");
    }
});
exports.rightAxisGranularityProperty.register(MPChartBase);
exports.xAxisLabelPositionProperty = new view_1.Property({
    name: "xAxisLabelPosition",
});
exports.xAxisLabelPositionProperty.register(MPChartBase);
exports.xAxisLineColorProperty = new view_1.Property({
    name: "xAxisLineColor",
    valueConverter: function (v) {
        if (v) {
            return new color_1.Color(v);
        }
        else {
            return new color_1.Color("#000000");
        }
    }
});
exports.xAxisLineColorProperty.register(MPChartBase);
exports.xAxisLineColorCssProperty = new text_base_1.CssProperty({
    name: "xAxisLineColor",
    cssName: "x-axis-line-color",
    valueConverter: function (v) {
        if (v) {
            return new color_1.Color(v);
        }
        else {
            return new color_1.Color("#000000");
        }
    }
});
exports.xAxisLineColorCssProperty.register(text_base_1.Style);
exports.leftAxisLineColorProperty = new view_1.Property({
    name: "leftAxisLineColor",
    valueConverter: function (v) {
        if (v) {
            return new color_1.Color(v);
        }
        else {
            return new color_1.Color("#000000");
        }
    }
});
exports.leftAxisLineColorProperty.register(MPChartBase);
exports.leftAxisLineColorCssProperty = new text_base_1.CssProperty({
    name: "leftAxisLineColor",
    cssName: "left-axis-line-color",
    valueConverter: function (v) {
        if (v) {
            return new color_1.Color(v);
        }
        else {
            return new color_1.Color("#000000");
        }
    }
});
exports.leftAxisLineColorCssProperty.register(text_base_1.Style);
exports.rightAxisLineColorProperty = new view_1.Property({
    name: "rightAxisLineColor",
    valueConverter: function (v) {
        if (v) {
            return new color_1.Color(v);
        }
        else {
            return new color_1.Color("#000000");
        }
    }
});
exports.rightAxisLineColorProperty.register(MPChartBase);
exports.rightAxisLineColorCssProperty = new text_base_1.CssProperty({
    name: "rightAxisLineColor",
    cssName: "right-axis-line-color",
    valueConverter: function (v) {
        if (v) {
            return new color_1.Color(v);
        }
        else {
            return new color_1.Color("#000000");
        }
    }
});
exports.rightAxisLineColorCssProperty.register(text_base_1.Style);
exports.xAxisTextColorProperty = new view_1.Property({
    name: "xAxisTextColor",
    valueConverter: function (v) {
        if (v) {
            return new color_1.Color(v);
        }
        else {
            return new color_1.Color("#000000");
        }
    }
});
exports.xAxisTextColorProperty.register(MPChartBase);
exports.xAxisTextColorCssProperty = new text_base_1.CssProperty({
    name: "xAxisTextColor",
    cssName: "x-axis-text-color",
    valueConverter: function (v) {
        if (v) {
            return new color_1.Color(v);
        }
        else {
            return new color_1.Color("#000000");
        }
    }
});
exports.xAxisTextColorCssProperty.register(text_base_1.Style);
exports.leftAxisTextColorProperty = new view_1.Property({
    name: "leftAxisTextColor",
    valueConverter: function (v) {
        if (v) {
            return new color_1.Color(v);
        }
        else {
            return new color_1.Color("#000000");
        }
    }
});
exports.leftAxisTextColorProperty.register(MPChartBase);
exports.leftAxisTextColorCssProperty = new text_base_1.CssProperty({
    name: "leftAxisTextColor",
    cssName: "left-axis-text-color",
    valueConverter: function (v) {
        if (v) {
            return new color_1.Color(v);
        }
        else {
            return new color_1.Color("#000000");
        }
    }
});
exports.leftAxisTextColorCssProperty.register(text_base_1.Style);
exports.rightAxisTextColorProperty = new view_1.Property({
    name: "rightAxisTextColor",
    valueConverter: function (v) {
        if (v) {
            return new color_1.Color(v);
        }
        else {
            return new color_1.Color("#000000");
        }
    }
});
exports.rightAxisTextColorProperty.register(MPChartBase);
exports.rightAxisTextColorCssProperty = new text_base_1.CssProperty({
    name: "rightAxisTextColor",
    cssName: "right-axis-text-color",
    valueConverter: function (v) {
        if (v) {
            return new color_1.Color(v);
        }
        else {
            return new color_1.Color("#000000");
        }
    }
});
exports.rightAxisTextColorCssProperty.register(text_base_1.Style);
exports.xAxisMinValueProperty = new view_1.Property({
    name: "xAxisMinValue",
    defaultValue: 0,
    valueConverter: function (v) {
        console.log("xAxisMinValueProperty common", v);
        if (parseFloat(v) !== NaN) {
            return parseFloat(v);
        }
        throw new Error("Property 'xAxisMinValue' must be a number");
    }
});
exports.xAxisMinValueProperty.register(MPChartBase);
exports.xAxisMaxValueProperty = new view_1.Property({
    name: "xAxisMaxValue",
    defaultValue: 0,
    valueConverter: function (v) {
        if (parseFloat(v) !== NaN) {
            return parseFloat(v);
        }
        throw new Error("Property 'xAxisMaxValue' must be a number");
    }
});
exports.xAxisMaxValueProperty.register(MPChartBase);
exports.leftAxisMinValueProperty = new view_1.Property({
    name: "leftAxisMinValue",
    defaultValue: 0,
    valueConverter: function (v) {
        if (parseFloat(v) !== NaN) {
            return parseFloat(v);
        }
        throw new Error("Property 'leftAxisMaxValue' must be a number");
    }
});
exports.leftAxisMinValueProperty.register(MPChartBase);
exports.leftAxisMaxValueProperty = new view_1.Property({
    name: "leftAxisMaxValue",
    defaultValue: 0,
    valueConverter: function (v) {
        if (parseFloat(v) !== NaN) {
            return parseFloat(v);
        }
        throw new Error("Property 'leftAxisMaxValue' must be a number");
    }
});
exports.leftAxisMaxValueProperty.register(MPChartBase);
exports.rightAxisMinValueProperty = new view_1.Property({
    name: "rightAxisMinValue",
    defaultValue: 0,
    valueConverter: function (v) {
        if (parseFloat(v) !== NaN) {
            return parseFloat(v);
        }
        throw new Error("Property 'rightAxisMaxValue' must be a number");
    }
});
exports.rightAxisMinValueProperty.register(MPChartBase);
exports.rightAxisMaxValueProperty = new view_1.Property({
    name: "rightAxisMaxValue",
    defaultValue: 0,
    valueConverter: function (v) {
        if (parseFloat(v) !== NaN) {
            return parseFloat(v);
        }
        throw new Error("Property 'rightAxisMaxValue' must be a number");
    }
});
exports.rightAxisMaxValueProperty.register(MPChartBase);
exports.leftAxisFormatterProperty = new view_1.Property({
    name: "leftAxisFormatter",
    valueChanged: function (value) {
        console.log("value Change ", value);
    }
});
exports.leftAxisFormatterProperty.register(MPChartBase);
exports.rightAxisFormatterProperty = new view_1.Property({
    name: "rightAxisFormatter",
});
exports.rightAxisFormatterProperty.register(MPChartBase);
exports.fontProperty = new view_1.Property({
    name: "font",
});
exports.fontProperty.register(MPChartBase);
exports.showValueLabelsProperty = new view_1.Property({
    name: "showValueLabels",
    defaultValue: false,
    valueConverter: view_1.booleanConverter
});
exports.showValueLabelsProperty.register(MPChartBase);
exports.showLeftAxisProperty = new view_1.Property({
    name: "showLeftAxis",
    defaultValue: true,
    valueConverter: view_1.booleanConverter
});
exports.showLeftAxisProperty.register(MPChartBase);
exports.showRightAxisProperty = new view_1.Property({
    name: "showRightAxis",
    defaultValue: true,
    valueConverter: view_1.booleanConverter
});
exports.showRightAxisProperty.register(MPChartBase);
exports.markerProperty = new view_1.Property({
    name: "marker",
});
exports.markerProperty.register(MPChartBase);
//# sourceMappingURL=nativescript-mpchart.common.js.map